---
title: Upload a schema
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/go)

[Schema Validation](https://developers.cloudflare.com/api/go/resources/schema_validation)

[Schemas](https://developers.cloudflare.com/api/go/resources/schema_validation/subresources/schemas)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Upload a schema

client.SchemaValidation.Schemas.New(ctx, params) (\*[PublicSchema](<https://developers.cloudflare.com/api/go/resources/schema_validation#(resource)%20schema_validation.schemas%20%3E%20(model)%20public_schema%20%3E%20(schema)>), error)

POST/zones/{zone\_id}/schema\_validation/schemas

Uploads an OpenAPI schema that defines expected request formats for API operations.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### Accepted Permissions (at least one required)

`Account API Gateway``Domain API Gateway`

##### ParametersExpand Collapse

<details>

<summary>

params SchemaNewParams

</summary>

ZoneID param.Field\[string]

Path param: Identifier.

maxLength32

<a href="#(resource)%20schema_validation.schemas%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20zone_id">Link to this property</a>

<details>

<summary>

Kind param.Field\[<a href="https://developers.cloudflare.com/api/go/resources/schema_validation/subresources/schemas/methods/create#(resource)%20schema_validation.schemas%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20kind%20%3E%20(schema)">SchemaNewParamsKind</a>]

Body param: The kind of the schema

</summary>

const SchemaNewParamsKindOpenAPIV3 <a href="https://developers.cloudflare.com/api/go/resources/schema_validation/subresources/schemas/methods/create#(resource)%20schema_validation.schemas%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20kind%20%3E%20(schema)">SchemaNewParamsKind</a> = "openapi\_v3"

<a href="#(resource)%20schema_validation.schemas%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20kind%20%3E%20(schema)%20%3E%20(member)%200">Link to this property</a>

</details>

<a href="#(resource)%20schema_validation.schemas%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20kind">Link to this property</a>

Name param.Field\[string]

Body param: A human-readable name for the schema

<a href="#(resource)%20schema_validation.schemas%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20name">Link to this property</a>

Source param.Field\[string]

Body param: The raw schema, e.g., the OpenAPI schema, either as JSON or YAML

<a href="#(resource)%20schema_validation.schemas%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20source">Link to this property</a>

ValidationEnabled param.Field\[bool]

Body param: An indicator if this schema is enabled

<a href="#(resource)%20schema_validation.schemas%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20validation_enabled">Link to this property</a>

</details>

[Link to this property](<#(resource)%20schema_validation.schemas%20%3E%20(method)%20create%20%3E%20(params)%20default>)

##### ReturnsExpand Collapse

<details>

<summary>

type PublicSchema struct{…}

A schema used in schema validation

</summary>

CreatedAt Time

formatdate-time

<a href="#(resource)%20schema_validation.schemas%20%3E%20(model)%20public_schema%20%3E%20(schema)%20%3E%20(property)%20created_at">Link to this property</a>

Kind PublicSchemaKind

The kind of the schema

<a href="#(resource)%20schema_validation.schemas%20%3E%20(model)%20public_schema%20%3E%20(schema)%20%3E%20(property)%20kind">Link to this property</a>

Name string

A human-readable name for the schema

<a href="#(resource)%20schema_validation.schemas%20%3E%20(model)%20public_schema%20%3E%20(schema)%20%3E%20(property)%20name">Link to this property</a>

SchemaID string

A unique identifier of this schema

maxLength36

minLength36

formatuuid

<a href="#(resource)%20schema_validation.schemas%20%3E%20(model)%20public_schema%20%3E%20(schema)%20%3E%20(property)%20schema_id">Link to this property</a>

Source string

The raw schema, e.g., the OpenAPI schema, either as JSON or YAML

<a href="#(resource)%20schema_validation.schemas%20%3E%20(model)%20public_schema%20%3E%20(schema)%20%3E%20(property)%20source">Link to this property</a>

ValidationEnabled boolOptional

An indicator if this schema is enabled

<a href="#(resource)%20schema_validation.schemas%20%3E%20(model)%20public_schema%20%3E%20(schema)%20%3E%20(property)%20validation_enabled">Link to this property</a>

</details>

[Link to this property](<#(resource)%20schema_validation.schemas%20%3E%20(model)%20public_schema%20%3E%20(schema)>)

### Upload a schema

Go

HTTPTypeScriptPythonGoTerraform

```
package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/option"
  "github.com/cloudflare/cloudflare-go/schema_validation"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  publicSchema, err := client.SchemaValidation.Schemas.New(context.TODO(), schema_validation.SchemaNewParams{
    ZoneID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"),
    Kind: cloudflare.F(schema_validation.SchemaNewParamsKindOpenAPIV3),
    Name: cloudflare.F("petstore schema"),
    Source: cloudflare.F("<schema file contents>"),
    ValidationEnabled: cloudflare.F(true),
  })
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", publicSchema.SchemaID)
}
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "locations": [
          ".paths[\"/user/{username}\"].put"
        ],
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "locations": [
          ".paths[\"/user/{username}\"].put"
        ],
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "created_at": "2014-01-01T05:20:00.12345Z",
    "kind": "openapi_v3",
    "name": "petstore schema",
    "schema_id": "f174e90a-fafe-4643-bbbc-4a0ed4fc8415",
    "source": "<schema file contents>",
    "validation_enabled": true
  },
  "success": true
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "locations": [
          ".paths[\"/user/{username}\"].put"
        ],
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "locations": [
          ".paths[\"/user/{username}\"].put"
        ],
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "created_at": "2014-01-01T05:20:00.12345Z",
    "kind": "openapi_v3",
    "name": "petstore schema",
    "schema_id": "f174e90a-fafe-4643-bbbc-4a0ed4fc8415",
    "source": "<schema file contents>",
    "validation_enabled": true
  },
  "success": true
}
```